diff a/test/langtools/tools/javac/valhalla/value-objects/PreloadAttributeTest.java b/test/langtools/tools/javac/valhalla/value-objects/PreloadAttributeTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/PreloadAttributeTest.java
@@ -0,0 +1,110 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8280164
+ * @summary Check emission of Preload attribute
+ * @modules jdk.jdeps/com.sun.tools.classfile
+ * @enablePreview
+ * @run main PreloadAttributeTest
+ */
+
+import com.sun.tools.classfile.*;
+import com.sun.tools.classfile.ConstantPool.CONSTANT_Class_info;
+
+public class PreloadAttributeTest {
+
+    final value class V1 {}
+    final value class V2 {}
+    final value class V3 {}
+    final value class V4 {}
+    final value class V5 {}
+    final value class V6 {}
+    final value class V7 {}
+    final value class V8 {}
+    final value class V9 {}
+
+    static final value class X {
+        final V1 [] v1 = null; // field descriptor, encoding array type - no preload.
+        V2 foo() {  // method descriptor encoding value type, to be preloaded
+            return null;
+        }
+        void foo(V3 v3) { // method descriptor encoding value type, to be preloaded
+        }
+        void foo(int x) {
+            V4 [] v4 = null; // local variable encoding array type - no preload.
+        }
+        void goo(V6[] v6) { // parameter uses value type but as array component - no preload.
+            V5 v5 = null;  // preload value type used for local type.
+            if (v5 == null) {
+                // ...
+            } else {
+               V5 [] v52 = null;
+            }
+        }
+        final V7 v7 = null; // field descriptor uses value type - to be preloaded.
+        V8 [] goo(V9 [] v9) { // neither V8 nor V9 call for preload being array component types
+            return null;
+        }
+    }
+    // So we expect ONLY V2, V3 V5, V7 to be in Preload list
+
+    public static void main(String[] args) throws Exception {
+        ClassFile cls = ClassFile.read(PreloadAttributeTest.class.getResourceAsStream("PreloadAttributeTest$X.class"));
+
+        if (cls == null) {
+            throw new AssertionError("Could not locate the class files");
+        }
+
+        /* Check emission of Preload attribute */
+        Preload_attribute preloads = (Preload_attribute) cls.attributes.get(Attribute.Preload);
+        if (preloads == null) {
+            throw new AssertionError("Missing Preload attribute!");
+        }
+        if (preloads.number_of_classes != 4) {
+            throw new AssertionError("Incorrect number of Preload classes");
+        }
+
+        int mask = 0x56;
+        for (int i = 0; i < preloads.number_of_classes; i++) {
+            CONSTANT_Class_info clsInfo = cls.constant_pool.getClassInfo(
+                                  preloads.value_class_info_index[i]);
+            switch (clsInfo.getName()) {
+                case "PreloadAttributeTest$V2":
+                    mask &= ~2; break;
+                case "PreloadAttributeTest$V3":
+                    mask &= ~4; break;
+                case "PreloadAttributeTest$V5":
+                    mask &= ~16; break;
+                case "PreloadAttributeTest$V7" :
+                    mask &= ~64; break;
+                default:
+                    throw new AssertionError("Unexpected Preload class entry!");
+            }
+        }
+        if (mask != 0) {
+          throw new AssertionError("Some Preload class entries are missing!");
+        }
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/ValueBasedFlagsTest.java b/test/langtools/tools/javac/valhalla/value-objects/ValueBasedFlagsTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/ValueBasedFlagsTest.java
@@ -0,0 +1,94 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8331462
+ * @summary [lworld] javac is setting the ACC_STRICT flag for value-based classes
+ * @library /tools/lib
+ * @modules
+ *      jdk.compiler/com.sun.tools.javac.code
+ *      jdk.compiler/com.sun.tools.javac.util
+ *      jdk.compiler/com.sun.tools.javac.api
+ *      jdk.compiler/com.sun.tools.javac.file
+ *      jdk.compiler/com.sun.tools.javac.main
+ *      jdk.jdeps/com.sun.tools.classfile
+ * @build toolbox.ToolBox toolbox.JavacTask
+ * @run main ValueBasedFlagsTest
+ */
+
+import java.nio.file.Path;
+import java.nio.file.Paths;
+
+import com.sun.tools.javac.code.Flags;
+import com.sun.tools.javac.util.Assert;
+import com.sun.tools.classfile.ClassFile;
+
+import toolbox.TestRunner;
+import toolbox.ToolBox;
+import toolbox.JavacTask;
+import toolbox.Task;
+
+public class ValueBasedFlagsTest extends TestRunner {
+    ToolBox tb = new ToolBox();
+
+    public ValueBasedFlagsTest() {
+        super(System.err);
+    }
+
+    protected void runTests() throws Exception {
+        runTests(m -> new Object[] { Paths.get(m.getName()) });
+    }
+
+    Path[] findJavaFiles(Path... paths) throws Exception {
+        return tb.findJavaFiles(paths);
+    }
+
+    public static void main(String... args) throws Exception {
+        new ValueBasedFlagsTest().runTests();
+    }
+
+    @Test
+    public void testValueBased(Path base) throws Exception {
+        Path src = base.resolve("src");
+        tb.writeJavaFiles(src,
+                """
+                package java.lang;
+                @jdk.internal.ValueBased
+                final class ValueBasedTest {}
+                """);
+        Path classes = base.resolve("classes");
+        tb.createDirectories(classes);
+
+        new toolbox.JavacTask(tb)
+                .options("--patch-module", "java.base=" + src.toString(),
+                        "--enable-preview", "-source", Integer.toString(Runtime.version().feature()))
+                .outdir(classes)
+                .files(findJavaFiles(src))
+                .run()
+                .writeAll();
+        Path classFilePath = classes.resolve("java", "lang", "ValueBasedTest.class");
+        ClassFile classFile = ClassFile.read(classFilePath.toFile());
+        Assert.check((classFile.access_flags.flags & Flags.ACC_STRICT) == 0);
+    }
+}
diff a/test/langtools/tools/javac/valhalla/value-objects/ValueCreationTest.java b/test/langtools/tools/javac/valhalla/value-objects/ValueCreationTest.java
--- /dev/null
+++ b/test/langtools/tools/javac/valhalla/value-objects/ValueCreationTest.java
@@ -0,0 +1,98 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @summary Check code generation for value creation ops
+ * @modules jdk.compiler/com.sun.tools.javac.util jdk.jdeps/com.sun.tools.javap
+ * @enablePreview
+ * @run main ValueCreationTest
+ */
+
+import java.io.PrintWriter;
+import java.io.StringWriter;
+import java.nio.file.Paths;
+
+public class ValueCreationTest {
+
+    static final value class Point {
+
+        final int x;
+        final int y;
+
+        Point (int x, int y) {
+            this.x = x;
+            this.y = y;
+        }
+
+        public static void main(String [] args) {
+            Point p = new Point(10, 20);
+        }
+    }
+
+    public static void main(String[] args) {
+        new ValueCreationTest().run();
+    }
+
+    void run() {
+        String [] params = new String [] { "-v",
+                                            Paths.get(System.getProperty("test.classes"),
+                                                "ValueCreationTest$Point.class").toString() };
+        runCheck(params, new String [] {
+
+         "final value class ValueCreationTest$Point",
+         "flags: (0x0010) ACC_FINAL",
+         "ValueCreationTest$Point(int, int);",
+         "descriptor: (II)V",
+         "flags: (0x0000)",
+         "0: aload_0",
+         "1: iload_1",
+         "2: putfield      #1                  // Field x:I",
+         "5: aload_0",
+         "6: iload_2",
+         "7: putfield      #7                  // Field y:I",
+        "10: aload_0",
+        "11: invokespecial #10                 // Method java/lang/Object.\"<init>\":()V",
+         });
+     }
+
+    void runCheck(String [] params, String [] expectedOut) {
+        StringWriter s;
+        String out;
+
+        try (PrintWriter pw = new PrintWriter(s = new StringWriter())) {
+            com.sun.tools.javap.Main.run(params, pw);
+            out = s.toString();
+        }
+        int errors = 0;
+        for (String eo: expectedOut) {
+            if (!out.contains(eo)) {
+                System.err.println("Match not found for string: " + eo);
+                errors++;
+            }
+        }
+        if (errors > 0) {
+            throw new AssertionError("Unexpected javap output: " + out);
+        }
+    }
+}
